﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Batch_OdataV4_Core.Models;
using Microsoft.AspNet.OData;
using Microsoft.AspNet.OData.Query;

namespace Batch_OdataV4_Core.Controllers
{
    [Route("api/[controller]")]
    public class BooksController : ODataController
    {
  
        // GET api/values
        [HttpGet]
        [EnableQuery]
        [System.Web.Http.AllowAnonymous]
  
        public IQueryable<TreeData> Get(ODataQueryOptions opts)
        {
            var data = TreeData.GetSelfData().AsQueryable();

            var count = data.Count();

            //perform filter

            if (opts.Filter != null)

                data = opts.Filter.ApplyTo(data, new ODataQuerySettings()).Cast<TreeData>();


            if (opts.Skip != null)

                data = opts.Skip.ApplyTo(data, new ODataQuerySettings());  //perform skip

            if (opts.Top != null)

                data = opts.Top.ApplyTo(data, new ODataQuerySettings());  //perform take


            return data.AsQueryable();
        }

      
    }
}
